﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;
using System.Diagnostics;
using System.Collections;

namespace _113608
{
    public partial class Form1 : Form
    {
        NodesOptionManager option = new NodesOptionManager();
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int counter = 0;
            GenerateNodes(ultraTree1.Nodes, counter, 5, 4);
            ultraTree1.NodeLevelOverrides[0].NodeStyle = NodeStyle.OptionButton;
            ultraTree1.NodeLevelOverrides[1].NodeStyle = NodeStyle.OptionButton;
            ultraTree1.NodeLevelOverrides[2].NodeStyle = NodeStyle.OptionButton;
            
        }

        private void GenerateNodes(Infragistics.Win.UltraWinTree.TreeNodesCollection treeNodesCollection, int counter, int dept, int nodes)
        {
            if (counter >= dept)
                return;

            for (int i = 0; i < nodes; i++)
            {
                UltraTreeNode node = treeNodesCollection.Add();
                option.Nodes.Add(node);
                node.Text = string.Format("node{0}", counter);
                GenerateNodes(node.Nodes, counter + 1, dept, nodes);
            }
        }

        private void ultraTree1_BeforeCheck(object sender, BeforeCheckEventArgs e)
        {
           // e.Cancel = ((DisableCheckbox)ultraTree1.CreationFilter).List.Contains(e.TreeNode);
        }

    }

    class NodesOptionManager: IDisposable 
    {
        internal bool skipChange = false;

        internal class BindingListWithRemoving<T> : BindingList<T>
        {
            protected override void RemoveItem(int index)
            {
                if (BeforeRemove != null)
                    BeforeRemove(this,
                          new ListChangedEventArgs(ListChangedType.ItemDeleted, index));

                base.RemoveItem(index);
            }

            public event EventHandler<ListChangedEventArgs> BeforeRemove;
        }

        public BindingListWithRemoving<UltraTreeNode> Nodes = new BindingListWithRemoving<UltraTreeNode>();

        public NodesOptionManager()
        {
            Nodes.ListChanged += new ListChangedEventHandler(Nodes_ListChanged);
            Nodes.BeforeRemove += new EventHandler<ListChangedEventArgs>(Nodes_BeforeRemove);
        }

        void Nodes_ListChanged(object sender, ListChangedEventArgs e)
        {
           if(e.ListChangedType == ListChangedType.ItemAdded )
               ((BindingListWithRemoving<UltraTreeNode>)sender)[e.NewIndex].SubObjectPropChanged += new Infragistics.Shared.SubObjectPropChangeEventHandler(node_SubObjectPropChanged);
        }

        void Nodes_BeforeRemove(object sender, ListChangedEventArgs e)
        {
            ((BindingListWithRemoving<UltraTreeNode>)sender)[e.NewIndex].SubObjectPropChanged -= new Infragistics.Shared.SubObjectPropChangeEventHandler(node_SubObjectPropChanged);
        }
       

        public void Dispose()
        {
            foreach (UltraTreeNode node in this.Nodes)
            {
                node.SubObjectPropChanged -=new Infragistics.Shared.SubObjectPropChangeEventHandler(node_SubObjectPropChanged);
            }
            Nodes.Clear();
          
        }

        void node_SubObjectPropChanged(Infragistics.Shared.PropChangeInfo propChange)
        {
            if (!skipChange &&
                (Infragistics.Win.UltraWinTree.PropertyIds)propChange.PropId == Infragistics.Win.UltraWinTree.PropertyIds.CheckedState &&
                ((UltraTreeNode)propChange.Source).CheckedState == CheckState.Checked )
            {
                skipChange = true;
                SetUnchecked((UltraTreeNode)propChange.Source);
                skipChange = false;
            }
        }

        private void SetUnchecked(UltraTreeNode ultraTreeNode)
        { 
            foreach (UltraTreeNode node in this.Nodes)
            {
                if (!node.Equals(ultraTreeNode))
                    node.CheckedState = CheckState.Unchecked;
            }
            
        }
    }
}
